diff --git a/QMP/README b/QMP/README
index 9334c25..35a80c7 100644
--- a/QMP/README
+++ b/QMP/README
@@ -15,8 +15,9 @@ QMP is JSON[1] based and has the following features:
 
 For more information, please, refer to the following files:
 
-o qmp-spec.txt    QEMU Monitor Protocol current specification
-o qmp-events.txt  List of available asynchronous events
+o qmp-spec.txt      QEMU Monitor Protocol current specification
+o qmp-commands.txt  QMP supported commands
+o qmp-events.txt    List of available asynchronous events
 
 There are also two simple Python scripts available:
 
diff --git a/QMP/qmp-commands.txt b/QMP/qmp-commands.txt
new file mode 100644
index 0000000..b1b0e02
--- /dev/null
+++ b/QMP/qmp-commands.txt
@@ -0,0 +1,1033 @@
+                        QMP Supported Commands
+                        ----------------------
+
+This document describes all commands currently supported by QMP.
+
+Most of the time their usage is exactly the same as in the user Monitor,
+this means that any other document which also describe commands (the manpage,
+QEMU's manual, etc) can and should be consulted.
+
+QMP has two types of commands: regular and query commands. Regular commands
+usually change the Virtual Machine's state someway, while query commands just
+return information. The sections below are divided accordingly.
+
+It's important to observe that the 'example' subsection is different for regular
+and query commands. For the former, a complete input line as it should be issued
+by the Client is shown. For the latter, what is shown is the complete Server
+response, whose members might be in different order when in real protocol usage.
+
+Also note that most examples are indented, so that they are easier to read
+and understand. However, in real protocol usage they are usually emitted as
+a single line.
+
+Please, refer to the QMP specification (QMP/qmp-spec.txt) for detailed
+information on the Server command and response formats.
+
+NOTE: This document is temporary and will be replaced soon.
+
+1. Regular Commands
+===================
+
+balloon
+-------
+
+Request VM to change its memory allocation (in bytes).
+
+Arguments:
+
+- "value": New memory allocation (json-int)
+
+Example:
+
+{ "execute": "balloon", "arguments": { "value": 536870912 } }
+
+block_passwd
+------------
+
+Set the password of encrypted block devices.
+
+Arguments:
+
+- "device": device name (json-string)
+- "password": password (json-string)
+
+Example:
+
+{ "execute": "block_passwd", "arguments": { "device": "ide0-hd0",
+                                            "password": "12345" } }
+
+change
+------
+
+Change a removable medium or VNC configuration.
+
+Arguments:
+
+- "device": device name (json-string)
+- "target": filename or item (json-string)
+- "arg": additional argument (json-string, optional)
+
+Examples:
+
+{ "execute": "change",
+             "arguments": { "device": "ide1-cd0",
+                            "target": "/srv/images/Fedora-12-x86_64-DVD.iso" } }
+
+{ "execute": "change",
+             "arguments": { "device": "vnc",
+                            "target": "password",
+                            "arg": "foobar1" } }
+
+closefd
+-------
+
+Close a file descriptor previously passed via SCM rights.
+
+Arguments:
+
+- "fdname": file descriptor name (json-string)
+
+Example:
+
+{ "execute": "closefd", "arguments": { "fdname": "fd1" } }
+
+cont
+----
+
+Resume emulation.
+
+Arguments: None.
+
+Example:
+
+{ "execute": "cont" }
+
+cpu
+---
+
+Set the default CPU.
+
+Arguments:
+
+- "index": the CPU's index (json-int)
+
+Example:
+
+{ "execute": "cpu", "arguments": { "index": 0 } }
+
+Note: CPUs' indexes are obtained with the 'query-cpus' command.
+
+device_add
+----------
+
+Add a device.
+
+Arguments:
+
+- "driver": the name of the new device's driver (json-string)
+- "bus": the device's parent bus (device tree path, json-string, optional)
+- "id": the device's ID, must be unique (json-string)
+- device properties
+
+Example:
+
+{ "execute": "device_add", "arguments": { "driver": "e1000", "id": "net1" } }
+
+Notes:
+
+(1) For detailed information about this command, please refer to the
+    'docs/qdev-device-use.txt' file.
+
+(2) It's possible to list device properties by running QEMU with the
+    "-device DEVICE,\?" command-line argument, where DEVICE is the device's name
+
+device_del
+----------
+
+Remove a device.
+
+Arguments:
+
+- "id": the device's ID (json-string)
+
+Example:
+
+{ "execute": "device_del", "arguments": { "id": "net1" } }
+
+eject
+-----
+
+Eject a removable medium.
+
+Arguments: 
+
+- force: force ejection (json-bool, optional)
+- device: device name (json-string)
+
+Example:
+
+{ "execute": "eject", "arguments": { "device": "ide1-cd0" } }
+
+Note: The "force" argument defaults to false.
+
+getfd
+-----
+
+Receive a file descriptor via SCM rights and assign it a name.
+
+Arguments:
+
+- "fdname": file descriptor name (json-string)
+
+Example:
+
+{ "execute": "getfd", "arguments": { "fdname": "fd1" } }
+
+memsave
+-------
+
+Save to disk virtual memory dump starting at 'val' of size 'size'.
+
+Arguments:
+
+- "val": the starting address (json-int)
+- "size": the memory size (json-int)
+- "filename": file path (json-string)
+
+Example:
+
+{ "execute": "memsave",
+             "arguments": { "val": 10,
+                            "size": 100,
+                            "filename": "/tmp/virtual-mem-dump" } }
+
+migrate
+-------
+
+Migrate to URI.
+
+Arguments:
+
+- "blk": block migration, full disk copy (json-bool, optional)
+- "inc": incremental disk copy (json-bool, optional)
+- "uri": Destination URI (json-string)
+
+Example:
+
+{ "execute": "migrate", "arguments": { "uri": "tcp:0:4446" } }
+
+Notes:
+
+(1) The 'query-migrate' command should be used to check migration's progress
+    and final result (this information is provided by the 'status' member)
+(2) All boolean arguments default to false
+(3) The user Monitor's "detach" argument is invalid in QMP and should not
+    be used
+
+migrate_cancel
+--------------
+
+Cancel the current migration.
+
+Arguments: None.
+
+Example:
+
+{ "execute": "migrate_cancel" }
+
+migrate_set_downtime
+--------------------
+
+Set maximum tolerated downtime (in seconds) for migrations.
+
+Arguments:
+
+- "value": maximum downtime (json-number)
+
+Example:
+
+{ "execute": "migrate_set_downtime", "arguments": { "value": 60 } }
+
+migrate_set_speed
+-----------------
+
+Set maximum speed for migrations.
+
+Arguments:
+
+- "value": maximum speed (json-number)
+
+Example:
+
+{ "execute": "migrate_set_speed", "arguments": { "value": 1024 } }
+
+netdev_add
+----------
+
+Add host network device.
+
+Arguments:
+
+- "type": the device type, "tap", "user", ... (json-string)
+- "id": the device's ID, must be unique (json-string)
+- device options
+
+Example:
+
+{ "execute": "netdev_add", "arguments": { "type": "user", "id": "netdev1" } }
+
+Note: The supported device options are the same ones supported by the '-net'
+      command-line argument, which are listed in the '-help' output or QEMU's
+      manual
+
+netdev_del
+----------
+
+Remove host network device.
+
+Arguments:
+
+- "id": the device's ID, must be unique (json-string)
+
+Example:
+
+{ "execute": "netdev_del", "arguments": { "id": "netdev1" } }
+
+pmemsave
+--------
+
+Save to disk physical memory dump starting at 'val' of size 'size'.
+
+Arguments:
+
+- "val": the starting address (json-int)
+- "size": the memory size (json-int)
+- "filename": file path (json-string)
+
+Example:
+
+{ "execute": "pmemsave",
+             "arguments": { "val": 10,
+                            "size": 100,
+                            "filename": "/tmp/physical-mem-dump" } }
+
+qmp_capabilities
+----------------
+
+Enable QMP capabilities.
+
+Arguments: None.
+
+Note: This command must be issued before issuing any other command.
+
+quit
+----
+
+Quit the emulator.
+
+Arguments: None.
+
+Example:
+
+{ "execute": "quit" }
+
+screendump
+----------
+
+Save screen into PPM image.
+
+Arguments:
+
+- "filename": file path (json-string)
+
+Example:
+
+{ "execute": "screendump", "arguments": { "filename": "/tmp/image" } }
+
+set_link
+--------
+
+Change the link status of a network adapter.
+
+Arguments:
+
+- "name": network device name (json-string)
+- "up": status is up (json-bool)
+
+Example:
+
+{ "execute": "set_link", "arguments": { "name": "e1000.0", "up": false } }
+
+stop
+----
+
+Stop the emulator.
+
+Arguments: None.
+
+Example:
+
+{ "execute": "stop" }
+
+system_powerdown
+----------------
+
+Send system power down event.
+
+Arguments: None.
+
+Example:
+
+{ "execute": "system_powerdown" }
+
+system_reset
+------------
+
+Reset the system.
+
+Arguments: None.
+
+Example:
+
+{ "execute": "system_reset" }
+
+
+2. Query Commands
+=================
+
+query-balloon
+-------------
+
+Show balloon information.
+
+Make an asynchronous request for balloon info. When the request completes a
+json-object will be returned containing the following data:
+
+- "actual": current balloon value in bytes (json-int)
+- "mem_swapped_in": Amount of memory swapped in bytes (json-int, optional)
+- "mem_swapped_out": Amount of memory swapped out in bytes (json-int, optional)
+- "major_page_faults": Number of major faults (json-int, optional)
+- "minor_page_faults": Number of minor faults (json-int, optional)
+- "free_mem":Total amount of free and unused memory in bytes (json-int,optional)
+- "total_mem": Total amount of available memory in bytes (json-int, optional)
+
+Example:
+
+{
+   "return":{
+      "actual":1073741824,
+      "mem_swapped_in":0,
+      "mem_swapped_out":0,
+      "major_page_faults":142,
+      "minor_page_faults":239245,
+      "free_mem":1014185984,
+      "total_mem":1044668416
+   }
+}
+
+query-block
+-----------
+
+Show the block devices.
+
+Each block device information is stored in a json-object and the returned value
+is a json-array of all devices.
+
+Each json-object contain the following:
+
+- "device": device name (json-string)
+- "type": device type (json-string)
+- "removable": true if the device is removable, false otherwise (json-bool)
+- "locked": true if the device is locked, false otherwise (json-bool)
+- "inserted": only present if the device is inserted, it is a json-object
+   containing the following:
+         - "file": device file name (json-string)
+         - "ro": true if read-only, false otherwise (json-bool)
+         - "drv": driver format name (json-string)
+         - "backing_file": backing file name if one is used (json-string)
+         - "encrypted": true if encrypted, false otherwise (json-bool)
+
+Example:
+
+{
+   "return":[
+      {
+         "device":"ide0-hd0",
+         "type":"hd",
+         "removable":false,
+         "locked":false,
+         "inserted":{
+            "file":"/tmp/foobar",
+            "ro":false,
+            "drv":"qcow2"
+         }
+      },
+      {
+         "device":"floppy0",
+         "type":"floppy",
+         "removable":true,
+         "locked":false
+      }
+   ]
+}
+
+query-blockstats
+----------------
+
+Show block device statistics.
+
+Each device statistic information is stored in a json-object and the returned
+value is a json-array of all devices.
+
+Each json-object contain the following:
+
+- "device": device name (json-string)
+- "stats": A json-object with the statistics information, it contains:
+    - "rd_bytes": bytes read (json-int)
+    - "wr_bytes": bytes written (json-int)
+    - "rd_operations": read operations (json-int)
+    - "wr_operations": write operations (json-int)
+    - "wr_highest_offset": Highest offset of a sector written since the
+                           BlockDriverState has been opened (json-int)
+    - "parent": Contains recursively the statistics of the underlying
+                protocol (e.g. the host file for a qcow2 image). If there is
+                no underlying protocol, this field is omitted
+                (json-object, optional)
+
+Example:
+
+{
+   "return":[
+      {
+         "device":"ide0-hd0",
+         "stats":{
+            "rd_bytes":512,
+            "wr_bytes":0,
+            "rd_operations":1,
+            "wr_operations":0,
+            "wr_highest_offset":0,
+            "parent":{
+               "stats":{
+                  "rd_bytes":1024,
+                  "wr_bytes":0,
+                  "rd_operations":2,
+                  "wr_operations":0,
+                  "wr_highest_offset":0
+               }
+            }
+         }
+      },
+      {
+         "device":"ide1-cd0",
+         "stats":{
+            "rd_bytes":0,
+            "wr_bytes":0,
+            "rd_operations":0,
+            "wr_operations":0,
+            "wr_highest_offset":0
+         }
+      }
+   ]
+}
+
+query-chardev
+-------------
+
+Each device is represented by a json-object. The returned value is a json-array
+of all devices.
+
+Each json-object contain the following:
+
+- "label": device's label (json-string)
+- "filename": device's file (json-string)
+
+Example:
+
+{
+   "return":[
+      {
+         "label":"monitor",
+         "filename":"stdio"
+      },
+      {
+         "label":"serial0",
+         "filename":"vc"
+      }
+   ]
+}
+
+query-commands
+--------------
+
+List QMP available commands.
+
+Each command is represented by a json-object, the returned value is a json-array
+of all commands.
+
+Each json-object contain:
+
+- "name": command's name (json-string)
+
+Example:
+
+{
+   "return":[
+      {
+         "name":"query-balloon"
+      },
+      {
+         "name":"system_powerdown"
+      }
+   ]
+}
+
+Note: This example has been shortened as the real response is too long.
+
+query-cpus
+----------
+
+Show CPU information.
+
+Return a json-array. Each CPU is represented by a json-object, which contains:
+
+- "cpu": CPU index (json-int)
+- "current": true if this is the current CPU, false otherwise (json-bool)
+- "halted": true if the cpu is halted, false otherwise (json-bool)
+- Current program counter. The key's name depends on the architecture:
+     "pc": i386/x86_64 (json-int)
+     "nip": PPC (json-int)
+     "pc" and "npc": sparc (json-int)
+     "PC": mips (json-int)
+
+Example:
+
+{
+   "return":[
+      {
+         "CPU":0,
+         "current":true,
+         "halted":false,
+         "pc":3227107138
+      },
+      {
+         "CPU":1,
+         "current":false,
+         "halted":true,
+         "pc":7108165
+      }
+   ]
+}
+
+query-hpet
+----------
+
+Show HPET state.
+
+Return a json-object with the following information:
+
+- "enabled": true if hpet if enabled, false otherwise (json-bool)
+
+Example:
+
+{ "return": { "enabled": true } }
+
+query-kvm
+---------
+
+Show KVM information.
+
+Return a json-object with the following information:
+
+- "enabled": true if KVM support is enabled, false otherwise (json-bool)
+- "present": true if QEMU has KVM support, false otherwise (json-bool)
+
+Example:
+
+{ "return": { "enabled": true, "present": true } }
+
+query-mice
+----------
+
+Show VM mice information.
+
+Each mouse is represented by a json-object, the returned value is a json-array
+of all mice.
+
+The mouse json-object contains the following:
+
+- "name": mouse's name (json-string)
+- "index": mouse's index (json-int)
+- "current": true if this mouse is receiving events, false otherwise (json-bool)
+- "absolute": true if the mouse generates absolute input events (json-bool)
+
+Example:
+
+{
+   "return":[
+      {
+         "name":"QEMU Microsoft Mouse",
+         "index":0,
+         "current":false,
+         "absolute":false
+      },
+      {
+         "name":"QEMU PS/2 Mouse",
+         "index":1,
+         "current":true,
+         "absolute":true
+      }
+   ]
+}
+
+query-migrate
+-------------
+
+Migration status.
+
+Return a json-object. If migration is active there will be another json-object
+with RAM migration status and if block migration is active another one with
+block migration status.
+
+The main json-object contains the following:
+
+- "status": migration status (json-string)
+- "ram": only present if "status" is "active", it is a json-object with the
+  following RAM information (in bytes):
+         - "transferred": amount transferred (json-int)
+         - "remaining": amount remaining (json-int)
+         - "total": total (json-int)
+- "disk": only present if "status" is "active" and it is a block migration,
+  it is a json-object with the following disk information (in bytes):
+         - "transferred": amount transferred (json-int)
+         - "remaining": amount remaining (json-int)
+         - "total": total (json-int)
+
+Examples:
+
+1. Migration is "completed":
+
+{ "return": { "status": "completed" } }
+
+2. Migration is "active" and it is not a block migration:
+
+{
+   "return":{
+      "status":"active",
+      "ram":{
+         "transferred":123,
+         "remaining":123,
+         "total":246
+      }
+   }
+}
+
+3. Migration is "active" and it is a block migration:
+
+{
+   "return":{
+      "status":"active",
+      "ram":{
+         "total":1057024,
+         "remaining":1053304,
+         "transferred":3720
+      },
+      "disk":{
+         "total":20971520,
+         "remaining":20880384,
+         "transferred":91136
+      }
+   }
+}
+
+query-name
+----------
+
+Show VM name.
+
+Return a json-object with the following information:
+
+- "name": VM's name (json-string, optional)
+
+Example:
+
+{ "return": { "name": "qemu-name" } }
+
+query-pci
+---------
+
+PCI buses and devices information.
+
+The returned value is a json-array of all buses. Each bus is represented by
+a json-object, which has a key with a json-array of all PCI devices attached
+to it. Each device is represented by a json-object.
+
+The bus json-object contains the following:
+
+- "bus": bus number (json-int)
+- "devices": a json-array of json-objects, each json-object represents a
+             PCI device
+
+The PCI device json-object contains the following:
+
+- "bus": identical to the parent's bus number (json-int)
+- "slot": slot number (json-int)
+- "function": function number (json-int)
+- "class_info": a json-object containing:
+     - "desc": device class description (json-string, optional)
+     - "class": device class number (json-int)
+- "id": a json-object containing:
+     - "device": device ID (json-int)
+     - "vendor": vendor ID (json-int)
+- "irq": device's IRQ if assigned (json-int, optional)
+- "qdev_id": qdev id string (json-string)
+- "pci_bridge": It's a json-object, only present if this device is a
+                PCI bridge, contains:
+     - "bus": bus number (json-int)
+     - "secondary": secondary bus number (json-int)
+     - "subordinate": subordinate bus number (json-int)
+     - "io_range": a json-object with memory range information (json-int)
+     - "memory_range": a json-object with memory range information (json-int)
+     - "prefetchable_range": a json-object with memory range
+                             information (json-int)
+     - "devices": a json-array of PCI devices if there's any attached (optional)
+- "regions": a json-array of json-objects, each json-object represents a
+             memory region of this device
+
+The memory range json-object contains the following:
+
+- "base": base memory address (json-int)
+- "limit": limit value (json-int)
+
+The region json-object can be an I/O region or a memory region, an I/O region
+json-object contains the following:
+
+- "type": "io" (json-string, fixed)
+- "bar": BAR number (json-int)
+- "address": memory address (json-int)
+- "size": memory size (json-int)
+
+A memory region json-object contains the following:
+
+- "type": "memory" (json-string, fixed)
+- "bar": BAR number (json-int)
+- "address": memory address (json-int)
+- "size": memory size (json-int)
+- "mem_type_64": true or false (json-bool)
+- "prefetch": true or false (json-bool)
+
+Example:
+
+{
+   "return":[
+      {
+         "bus":0,
+         "devices":[
+            {
+               "bus":0,
+               "qdev_id":"",
+               "slot":0,
+               "class_info":{
+                  "class":1536,
+                  "desc":"Host bridge"
+               },
+               "id":{
+                  "device":32902,
+                  "vendor":4663
+               },
+               "function":0,
+               "regions":[
+
+               ]
+            },
+            {
+               "bus":0,
+               "qdev_id":"",
+               "slot":1,
+               "class_info":{
+                  "class":1537,
+                  "desc":"ISA bridge"
+               },
+               "id":{
+                  "device":32902,
+                  "vendor":28672
+               },
+               "function":0,
+               "regions":[
+
+               ]
+            },
+            {
+               "bus":0,
+               "qdev_id":"",
+               "slot":1,
+               "class_info":{
+                  "class":257,
+                  "desc":"IDE controller"
+               },
+               "id":{
+                  "device":32902,
+                  "vendor":28688
+               },
+               "function":1,
+               "regions":[
+                  {
+                     "bar":4,
+                     "size":16,
+                     "address":49152,
+                     "type":"io"
+                  }
+               ]
+            },
+            {
+               "bus":0,
+               "qdev_id":"",
+               "slot":2,
+               "class_info":{
+                  "class":768,
+                  "desc":"VGA controller"
+               },
+               "id":{
+                  "device":4115,
+                  "vendor":184
+               },
+               "function":0,
+               "regions":[
+                  {
+                     "prefetch":true,
+                     "mem_type_64":false,
+                     "bar":0,
+                     "size":33554432,
+                     "address":4026531840,
+                     "type":"memory"
+                  },
+                  {
+                     "prefetch":false,
+                     "mem_type_64":false,
+                     "bar":1,
+                     "size":4096,
+                     "address":4060086272,
+                     "type":"memory"
+                  },
+                  {
+                     "prefetch":false,
+                     "mem_type_64":false,
+                     "bar":6,
+                     "size":65536,
+                     "address":-1,
+                     "type":"memory"
+                  }
+               ]
+            },
+            {
+               "bus":0,
+               "qdev_id":"",
+               "irq":11,
+               "slot":4,
+               "class_info":{
+                  "class":1280,
+                  "desc":"RAM controller"
+               },
+               "id":{
+                  "device":6900,
+                  "vendor":4098
+               },
+               "function":0,
+               "regions":[
+                  {
+                     "bar":0,
+                     "size":32,
+                     "address":49280,
+                     "type":"io"
+                  }
+               ]
+            }
+         ]
+      }
+   ]
+}
+
+Note: This example has been shortened as the real response is too long.
+
+query-status
+------------
+
+Return a json-object with the following information:
+
+- "running": true if the VM is running, or false if it is paused (json-bool)
+- "singlestep": true if the VM is in single step mode,
+                false otherwise (json-bool)
+
+Example:
+
+{ "return": { "running": true, "singlestep": false } }
+
+query-uuid
+----------
+
+Show VM UUID.
+
+Return a json-object with the following information:
+
+- "UUID": Universally Unique Identifier (json-string)
+
+Example:
+
+{ "return": { "UUID": "550e8400-e29b-41d4-a716-446655440000" } }
+
+query-version
+-------------
+
+Show QEMU version.
+
+Return a json-object with the following information:
+
+- "qemu": QEMU's version (json-string)
+- "package": package's version (json-string)
+
+Example:
+
+{ "return": { "qemu": "0.11.50", "package": "" } }
+
+query-vnc
+---------
+
+Show VNC server information.
+
+Return a json-object with server information. Connected clients are returned
+as a json-array of json-objects.
+
+The main json-object contains the following:
+
+- "enabled": true or false (json-bool)
+- "host": server's IP address (json-string)
+- "family": address family (json-string, "ipv4" or "ipv6")
+- "service": server's port number (json-string)
+- "auth": authentication method (json-string)
+- "clients": a json-array of all connected clients
+
+Clients are described by a json-object, each one contain the following:
+
+- "host": client's IP address (json-string)
+- "family": address family (json-string, "ipv4" or "ipv6")
+- "service": client's port number (json-string)
+- "x509_dname": TLS dname (json-string, optional)
+- "sasl_username": SASL username (json-string, optional)
+
+Example:
+
+{
+   "return":{
+      "enabled":true,
+      "host":"0.0.0.0",
+      "service":"50402",
+      "auth":"vnc",
+      "family":"ipv4",
+      "clients":[
+         {
+            "host":"127.0.0.1",
+            "service":"50401",
+            "family":"ipv4"
+         }
+      ]
+   }
+}